# immich-python-sdk
Immich API

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.134.0
- Package version: 1.134.0
- Generator version: 7.14.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/Marian-Braendle/immich-python-sdk.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/Marian-Braendle/immich-python-sdk.git`)

Then import the package:
```python
import immich_python_sdk
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import immich_python_sdk
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import immich_python_sdk
from immich_python_sdk.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://github.com/api
# See configuration.py for a list of all supported configuration parameters.
configuration = immich_python_sdk.Configuration(
    host = "https://github.com/api"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: cookie
configuration.api_key['cookie'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['cookie'] = 'Bearer'

# Configure API key authorization: api_key
configuration.api_key['api_key'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['api_key'] = 'Bearer'

# Configure Bearer authorization (JWT): bearer
configuration = immich_python_sdk.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with immich_python_sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = immich_python_sdk.APIKeysApi(api_client)
    api_key_create_dto = immich_python_sdk.APIKeyCreateDto() # APIKeyCreateDto | 

    try:
        api_response = api_instance.create_api_key(api_key_create_dto)
        print("The response of APIKeysApi->create_api_key:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling APIKeysApi->create_api_key: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://github.com/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIKeysApi* | [**create_api_key**](docs/APIKeysApi.md#create_api_key) | **POST** /api-keys | 
*APIKeysApi* | [**delete_api_key**](docs/APIKeysApi.md#delete_api_key) | **DELETE** /api-keys/{id} | 
*APIKeysApi* | [**get_api_key**](docs/APIKeysApi.md#get_api_key) | **GET** /api-keys/{id} | 
*APIKeysApi* | [**get_api_keys**](docs/APIKeysApi.md#get_api_keys) | **GET** /api-keys | 
*APIKeysApi* | [**update_api_key**](docs/APIKeysApi.md#update_api_key) | **PUT** /api-keys/{id} | 
*ActivitiesApi* | [**create_activity**](docs/ActivitiesApi.md#create_activity) | **POST** /activities | 
*ActivitiesApi* | [**delete_activity**](docs/ActivitiesApi.md#delete_activity) | **DELETE** /activities/{id} | 
*ActivitiesApi* | [**get_activities**](docs/ActivitiesApi.md#get_activities) | **GET** /activities | 
*ActivitiesApi* | [**get_activity_statistics**](docs/ActivitiesApi.md#get_activity_statistics) | **GET** /activities/statistics | 
*AlbumsApi* | [**add_assets_to_album**](docs/AlbumsApi.md#add_assets_to_album) | **PUT** /albums/{id}/assets | 
*AlbumsApi* | [**add_users_to_album**](docs/AlbumsApi.md#add_users_to_album) | **PUT** /albums/{id}/users | 
*AlbumsApi* | [**create_album**](docs/AlbumsApi.md#create_album) | **POST** /albums | 
*AlbumsApi* | [**delete_album**](docs/AlbumsApi.md#delete_album) | **DELETE** /albums/{id} | 
*AlbumsApi* | [**get_album_info**](docs/AlbumsApi.md#get_album_info) | **GET** /albums/{id} | 
*AlbumsApi* | [**get_album_statistics**](docs/AlbumsApi.md#get_album_statistics) | **GET** /albums/statistics | 
*AlbumsApi* | [**get_all_albums**](docs/AlbumsApi.md#get_all_albums) | **GET** /albums | 
*AlbumsApi* | [**remove_asset_from_album**](docs/AlbumsApi.md#remove_asset_from_album) | **DELETE** /albums/{id}/assets | 
*AlbumsApi* | [**remove_user_from_album**](docs/AlbumsApi.md#remove_user_from_album) | **DELETE** /albums/{id}/user/{userId} | 
*AlbumsApi* | [**update_album_info**](docs/AlbumsApi.md#update_album_info) | **PATCH** /albums/{id} | 
*AlbumsApi* | [**update_album_user**](docs/AlbumsApi.md#update_album_user) | **PUT** /albums/{id}/user/{userId} | 
*AssetsApi* | [**check_bulk_upload**](docs/AssetsApi.md#check_bulk_upload) | **POST** /assets/bulk-upload-check | checkBulkUpload
*AssetsApi* | [**check_existing_assets**](docs/AssetsApi.md#check_existing_assets) | **POST** /assets/exist | checkExistingAssets
*AssetsApi* | [**delete_assets**](docs/AssetsApi.md#delete_assets) | **DELETE** /assets | 
*AssetsApi* | [**download_asset**](docs/AssetsApi.md#download_asset) | **GET** /assets/{id}/original | 
*AssetsApi* | [**get_all_user_assets_by_device_id**](docs/AssetsApi.md#get_all_user_assets_by_device_id) | **GET** /assets/device/{deviceId} | getAllUserAssetsByDeviceId
*AssetsApi* | [**get_asset_info**](docs/AssetsApi.md#get_asset_info) | **GET** /assets/{id} | 
*AssetsApi* | [**get_asset_statistics**](docs/AssetsApi.md#get_asset_statistics) | **GET** /assets/statistics | 
*AssetsApi* | [**get_random**](docs/AssetsApi.md#get_random) | **GET** /assets/random | 
*AssetsApi* | [**play_asset_video**](docs/AssetsApi.md#play_asset_video) | **GET** /assets/{id}/video/playback | 
*AssetsApi* | [**replace_asset**](docs/AssetsApi.md#replace_asset) | **PUT** /assets/{id}/original | replaceAsset
*AssetsApi* | [**run_asset_jobs**](docs/AssetsApi.md#run_asset_jobs) | **POST** /assets/jobs | 
*AssetsApi* | [**update_asset**](docs/AssetsApi.md#update_asset) | **PUT** /assets/{id} | 
*AssetsApi* | [**update_assets**](docs/AssetsApi.md#update_assets) | **PUT** /assets | 
*AssetsApi* | [**upload_asset**](docs/AssetsApi.md#upload_asset) | **POST** /assets | 
*AssetsApi* | [**view_asset**](docs/AssetsApi.md#view_asset) | **GET** /assets/{id}/thumbnail | 
*AuthenticationApi* | [**change_password**](docs/AuthenticationApi.md#change_password) | **POST** /auth/change-password | 
*AuthenticationApi* | [**change_pin_code**](docs/AuthenticationApi.md#change_pin_code) | **PUT** /auth/pin-code | 
*AuthenticationApi* | [**get_auth_status**](docs/AuthenticationApi.md#get_auth_status) | **GET** /auth/status | 
*AuthenticationApi* | [**lock_auth_session**](docs/AuthenticationApi.md#lock_auth_session) | **POST** /auth/session/lock | 
*AuthenticationApi* | [**login**](docs/AuthenticationApi.md#login) | **POST** /auth/login | 
*AuthenticationApi* | [**logout**](docs/AuthenticationApi.md#logout) | **POST** /auth/logout | 
*AuthenticationApi* | [**reset_pin_code**](docs/AuthenticationApi.md#reset_pin_code) | **DELETE** /auth/pin-code | 
*AuthenticationApi* | [**setup_pin_code**](docs/AuthenticationApi.md#setup_pin_code) | **POST** /auth/pin-code | 
*AuthenticationApi* | [**sign_up_admin**](docs/AuthenticationApi.md#sign_up_admin) | **POST** /auth/admin-sign-up | 
*AuthenticationApi* | [**unlock_auth_session**](docs/AuthenticationApi.md#unlock_auth_session) | **POST** /auth/session/unlock | 
*AuthenticationApi* | [**validate_access_token**](docs/AuthenticationApi.md#validate_access_token) | **POST** /auth/validateToken | 
*DeprecatedApi* | [**get_random**](docs/DeprecatedApi.md#get_random) | **GET** /assets/random | 
*DownloadApi* | [**download_archive**](docs/DownloadApi.md#download_archive) | **POST** /download/archive | 
*DownloadApi* | [**get_download_info**](docs/DownloadApi.md#get_download_info) | **POST** /download/info | 
*DuplicatesApi* | [**get_asset_duplicates**](docs/DuplicatesApi.md#get_asset_duplicates) | **GET** /duplicates | 
*FacesApi* | [**create_face**](docs/FacesApi.md#create_face) | **POST** /faces | 
*FacesApi* | [**delete_face**](docs/FacesApi.md#delete_face) | **DELETE** /faces/{id} | 
*FacesApi* | [**get_faces**](docs/FacesApi.md#get_faces) | **GET** /faces | 
*FacesApi* | [**reassign_faces_by_id**](docs/FacesApi.md#reassign_faces_by_id) | **PUT** /faces/{id} | 
*JobsApi* | [**create_job**](docs/JobsApi.md#create_job) | **POST** /jobs | 
*JobsApi* | [**get_all_jobs_status**](docs/JobsApi.md#get_all_jobs_status) | **GET** /jobs | 
*JobsApi* | [**send_job_command**](docs/JobsApi.md#send_job_command) | **PUT** /jobs/{id} | 
*LibrariesApi* | [**create_library**](docs/LibrariesApi.md#create_library) | **POST** /libraries | 
*LibrariesApi* | [**delete_library**](docs/LibrariesApi.md#delete_library) | **DELETE** /libraries/{id} | 
*LibrariesApi* | [**get_all_libraries**](docs/LibrariesApi.md#get_all_libraries) | **GET** /libraries | 
*LibrariesApi* | [**get_library**](docs/LibrariesApi.md#get_library) | **GET** /libraries/{id} | 
*LibrariesApi* | [**get_library_statistics**](docs/LibrariesApi.md#get_library_statistics) | **GET** /libraries/{id}/statistics | 
*LibrariesApi* | [**scan_library**](docs/LibrariesApi.md#scan_library) | **POST** /libraries/{id}/scan | 
*LibrariesApi* | [**update_library**](docs/LibrariesApi.md#update_library) | **PUT** /libraries/{id} | 
*LibrariesApi* | [**validate**](docs/LibrariesApi.md#validate) | **POST** /libraries/{id}/validate | 
*MapApi* | [**get_map_markers**](docs/MapApi.md#get_map_markers) | **GET** /map/markers | 
*MapApi* | [**reverse_geocode**](docs/MapApi.md#reverse_geocode) | **GET** /map/reverse-geocode | 
*MemoriesApi* | [**add_memory_assets**](docs/MemoriesApi.md#add_memory_assets) | **PUT** /memories/{id}/assets | 
*MemoriesApi* | [**create_memory**](docs/MemoriesApi.md#create_memory) | **POST** /memories | 
*MemoriesApi* | [**delete_memory**](docs/MemoriesApi.md#delete_memory) | **DELETE** /memories/{id} | 
*MemoriesApi* | [**get_memory**](docs/MemoriesApi.md#get_memory) | **GET** /memories/{id} | 
*MemoriesApi* | [**remove_memory_assets**](docs/MemoriesApi.md#remove_memory_assets) | **DELETE** /memories/{id}/assets | 
*MemoriesApi* | [**search_memories**](docs/MemoriesApi.md#search_memories) | **GET** /memories | 
*MemoriesApi* | [**update_memory**](docs/MemoriesApi.md#update_memory) | **PUT** /memories/{id} | 
*NotificationsApi* | [**delete_notification**](docs/NotificationsApi.md#delete_notification) | **DELETE** /notifications/{id} | 
*NotificationsApi* | [**delete_notifications**](docs/NotificationsApi.md#delete_notifications) | **DELETE** /notifications | 
*NotificationsApi* | [**get_notification**](docs/NotificationsApi.md#get_notification) | **GET** /notifications/{id} | 
*NotificationsApi* | [**get_notifications**](docs/NotificationsApi.md#get_notifications) | **GET** /notifications | 
*NotificationsApi* | [**update_notification**](docs/NotificationsApi.md#update_notification) | **PUT** /notifications/{id} | 
*NotificationsApi* | [**update_notifications**](docs/NotificationsApi.md#update_notifications) | **PUT** /notifications | 
*NotificationsAdminApi* | [**create_notification**](docs/NotificationsAdminApi.md#create_notification) | **POST** /admin/notifications | 
*NotificationsAdminApi* | [**get_notification_template_admin**](docs/NotificationsAdminApi.md#get_notification_template_admin) | **POST** /admin/notifications/templates/{name} | 
*NotificationsAdminApi* | [**send_test_email_admin**](docs/NotificationsAdminApi.md#send_test_email_admin) | **POST** /admin/notifications/test-email | 
*OAuthApi* | [**finish_o_auth**](docs/OAuthApi.md#finish_o_auth) | **POST** /oauth/callback | 
*OAuthApi* | [**link_o_auth_account**](docs/OAuthApi.md#link_o_auth_account) | **POST** /oauth/link | 
*OAuthApi* | [**redirect_o_auth_to_mobile**](docs/OAuthApi.md#redirect_o_auth_to_mobile) | **GET** /oauth/mobile-redirect | 
*OAuthApi* | [**start_o_auth**](docs/OAuthApi.md#start_o_auth) | **POST** /oauth/authorize | 
*OAuthApi* | [**unlink_o_auth_account**](docs/OAuthApi.md#unlink_o_auth_account) | **POST** /oauth/unlink | 
*PartnersApi* | [**create_partner**](docs/PartnersApi.md#create_partner) | **POST** /partners/{id} | 
*PartnersApi* | [**get_partners**](docs/PartnersApi.md#get_partners) | **GET** /partners | 
*PartnersApi* | [**remove_partner**](docs/PartnersApi.md#remove_partner) | **DELETE** /partners/{id} | 
*PartnersApi* | [**update_partner**](docs/PartnersApi.md#update_partner) | **PUT** /partners/{id} | 
*PeopleApi* | [**create_person**](docs/PeopleApi.md#create_person) | **POST** /people | 
*PeopleApi* | [**get_all_people**](docs/PeopleApi.md#get_all_people) | **GET** /people | 
*PeopleApi* | [**get_person**](docs/PeopleApi.md#get_person) | **GET** /people/{id} | 
*PeopleApi* | [**get_person_statistics**](docs/PeopleApi.md#get_person_statistics) | **GET** /people/{id}/statistics | 
*PeopleApi* | [**get_person_thumbnail**](docs/PeopleApi.md#get_person_thumbnail) | **GET** /people/{id}/thumbnail | 
*PeopleApi* | [**merge_person**](docs/PeopleApi.md#merge_person) | **POST** /people/{id}/merge | 
*PeopleApi* | [**reassign_faces**](docs/PeopleApi.md#reassign_faces) | **PUT** /people/{id}/reassign | 
*PeopleApi* | [**update_people**](docs/PeopleApi.md#update_people) | **PUT** /people | 
*PeopleApi* | [**update_person**](docs/PeopleApi.md#update_person) | **PUT** /people/{id} | 
*SearchApi* | [**get_assets_by_city**](docs/SearchApi.md#get_assets_by_city) | **GET** /search/cities | 
*SearchApi* | [**get_explore_data**](docs/SearchApi.md#get_explore_data) | **GET** /search/explore | 
*SearchApi* | [**get_search_suggestions**](docs/SearchApi.md#get_search_suggestions) | **GET** /search/suggestions | 
*SearchApi* | [**search_assets**](docs/SearchApi.md#search_assets) | **POST** /search/metadata | 
*SearchApi* | [**search_person**](docs/SearchApi.md#search_person) | **GET** /search/person | 
*SearchApi* | [**search_places**](docs/SearchApi.md#search_places) | **GET** /search/places | 
*SearchApi* | [**search_random**](docs/SearchApi.md#search_random) | **POST** /search/random | 
*SearchApi* | [**search_smart**](docs/SearchApi.md#search_smart) | **POST** /search/smart | 
*ServerApi* | [**delete_server_license**](docs/ServerApi.md#delete_server_license) | **DELETE** /server/license | 
*ServerApi* | [**get_about_info**](docs/ServerApi.md#get_about_info) | **GET** /server/about | 
*ServerApi* | [**get_server_config**](docs/ServerApi.md#get_server_config) | **GET** /server/config | 
*ServerApi* | [**get_server_features**](docs/ServerApi.md#get_server_features) | **GET** /server/features | 
*ServerApi* | [**get_server_license**](docs/ServerApi.md#get_server_license) | **GET** /server/license | 
*ServerApi* | [**get_server_statistics**](docs/ServerApi.md#get_server_statistics) | **GET** /server/statistics | 
*ServerApi* | [**get_server_version**](docs/ServerApi.md#get_server_version) | **GET** /server/version | 
*ServerApi* | [**get_storage**](docs/ServerApi.md#get_storage) | **GET** /server/storage | 
*ServerApi* | [**get_supported_media_types**](docs/ServerApi.md#get_supported_media_types) | **GET** /server/media-types | 
*ServerApi* | [**get_theme**](docs/ServerApi.md#get_theme) | **GET** /server/theme | 
*ServerApi* | [**get_version_check**](docs/ServerApi.md#get_version_check) | **GET** /server/version-check | 
*ServerApi* | [**get_version_history**](docs/ServerApi.md#get_version_history) | **GET** /server/version-history | 
*ServerApi* | [**ping_server**](docs/ServerApi.md#ping_server) | **GET** /server/ping | 
*ServerApi* | [**set_server_license**](docs/ServerApi.md#set_server_license) | **PUT** /server/license | 
*SessionsApi* | [**create_session**](docs/SessionsApi.md#create_session) | **POST** /sessions | 
*SessionsApi* | [**delete_all_sessions**](docs/SessionsApi.md#delete_all_sessions) | **DELETE** /sessions | 
*SessionsApi* | [**delete_session**](docs/SessionsApi.md#delete_session) | **DELETE** /sessions/{id} | 
*SessionsApi* | [**get_sessions**](docs/SessionsApi.md#get_sessions) | **GET** /sessions | 
*SessionsApi* | [**lock_session**](docs/SessionsApi.md#lock_session) | **POST** /sessions/{id}/lock | 
*SharedLinksApi* | [**add_shared_link_assets**](docs/SharedLinksApi.md#add_shared_link_assets) | **PUT** /shared-links/{id}/assets | 
*SharedLinksApi* | [**create_shared_link**](docs/SharedLinksApi.md#create_shared_link) | **POST** /shared-links | 
*SharedLinksApi* | [**get_all_shared_links**](docs/SharedLinksApi.md#get_all_shared_links) | **GET** /shared-links | 
*SharedLinksApi* | [**get_my_shared_link**](docs/SharedLinksApi.md#get_my_shared_link) | **GET** /shared-links/me | 
*SharedLinksApi* | [**get_shared_link_by_id**](docs/SharedLinksApi.md#get_shared_link_by_id) | **GET** /shared-links/{id} | 
*SharedLinksApi* | [**remove_shared_link**](docs/SharedLinksApi.md#remove_shared_link) | **DELETE** /shared-links/{id} | 
*SharedLinksApi* | [**remove_shared_link_assets**](docs/SharedLinksApi.md#remove_shared_link_assets) | **DELETE** /shared-links/{id}/assets | 
*SharedLinksApi* | [**update_shared_link**](docs/SharedLinksApi.md#update_shared_link) | **PATCH** /shared-links/{id} | 
*StacksApi* | [**create_stack**](docs/StacksApi.md#create_stack) | **POST** /stacks | 
*StacksApi* | [**delete_stack**](docs/StacksApi.md#delete_stack) | **DELETE** /stacks/{id} | 
*StacksApi* | [**delete_stacks**](docs/StacksApi.md#delete_stacks) | **DELETE** /stacks | 
*StacksApi* | [**get_stack**](docs/StacksApi.md#get_stack) | **GET** /stacks/{id} | 
*StacksApi* | [**search_stacks**](docs/StacksApi.md#search_stacks) | **GET** /stacks | 
*StacksApi* | [**update_stack**](docs/StacksApi.md#update_stack) | **PUT** /stacks/{id} | 
*SyncApi* | [**delete_sync_ack**](docs/SyncApi.md#delete_sync_ack) | **DELETE** /sync/ack | 
*SyncApi* | [**get_delta_sync**](docs/SyncApi.md#get_delta_sync) | **POST** /sync/delta-sync | 
*SyncApi* | [**get_full_sync_for_user**](docs/SyncApi.md#get_full_sync_for_user) | **POST** /sync/full-sync | 
*SyncApi* | [**get_sync_ack**](docs/SyncApi.md#get_sync_ack) | **GET** /sync/ack | 
*SyncApi* | [**get_sync_stream**](docs/SyncApi.md#get_sync_stream) | **POST** /sync/stream | 
*SyncApi* | [**send_sync_ack**](docs/SyncApi.md#send_sync_ack) | **POST** /sync/ack | 
*SystemConfigApi* | [**get_config**](docs/SystemConfigApi.md#get_config) | **GET** /system-config | 
*SystemConfigApi* | [**get_config_defaults**](docs/SystemConfigApi.md#get_config_defaults) | **GET** /system-config/defaults | 
*SystemConfigApi* | [**get_storage_template_options**](docs/SystemConfigApi.md#get_storage_template_options) | **GET** /system-config/storage-template-options | 
*SystemConfigApi* | [**update_config**](docs/SystemConfigApi.md#update_config) | **PUT** /system-config | 
*SystemMetadataApi* | [**get_admin_onboarding**](docs/SystemMetadataApi.md#get_admin_onboarding) | **GET** /system-metadata/admin-onboarding | 
*SystemMetadataApi* | [**get_reverse_geocoding_state**](docs/SystemMetadataApi.md#get_reverse_geocoding_state) | **GET** /system-metadata/reverse-geocoding-state | 
*SystemMetadataApi* | [**get_version_check_state**](docs/SystemMetadataApi.md#get_version_check_state) | **GET** /system-metadata/version-check-state | 
*SystemMetadataApi* | [**update_admin_onboarding**](docs/SystemMetadataApi.md#update_admin_onboarding) | **POST** /system-metadata/admin-onboarding | 
*TagsApi* | [**bulk_tag_assets**](docs/TagsApi.md#bulk_tag_assets) | **PUT** /tags/assets | 
*TagsApi* | [**create_tag**](docs/TagsApi.md#create_tag) | **POST** /tags | 
*TagsApi* | [**delete_tag**](docs/TagsApi.md#delete_tag) | **DELETE** /tags/{id} | 
*TagsApi* | [**get_all_tags**](docs/TagsApi.md#get_all_tags) | **GET** /tags | 
*TagsApi* | [**get_tag_by_id**](docs/TagsApi.md#get_tag_by_id) | **GET** /tags/{id} | 
*TagsApi* | [**tag_assets**](docs/TagsApi.md#tag_assets) | **PUT** /tags/{id}/assets | 
*TagsApi* | [**untag_assets**](docs/TagsApi.md#untag_assets) | **DELETE** /tags/{id}/assets | 
*TagsApi* | [**update_tag**](docs/TagsApi.md#update_tag) | **PUT** /tags/{id} | 
*TagsApi* | [**upsert_tags**](docs/TagsApi.md#upsert_tags) | **PUT** /tags | 
*TimelineApi* | [**get_time_bucket**](docs/TimelineApi.md#get_time_bucket) | **GET** /timeline/bucket | 
*TimelineApi* | [**get_time_buckets**](docs/TimelineApi.md#get_time_buckets) | **GET** /timeline/buckets | 
*TrashApi* | [**empty_trash**](docs/TrashApi.md#empty_trash) | **POST** /trash/empty | 
*TrashApi* | [**restore_assets**](docs/TrashApi.md#restore_assets) | **POST** /trash/restore/assets | 
*TrashApi* | [**restore_trash**](docs/TrashApi.md#restore_trash) | **POST** /trash/restore | 
*UsersApi* | [**create_profile_image**](docs/UsersApi.md#create_profile_image) | **POST** /users/profile-image | 
*UsersApi* | [**delete_profile_image**](docs/UsersApi.md#delete_profile_image) | **DELETE** /users/profile-image | 
*UsersApi* | [**delete_user_license**](docs/UsersApi.md#delete_user_license) | **DELETE** /users/me/license | 
*UsersApi* | [**get_my_preferences**](docs/UsersApi.md#get_my_preferences) | **GET** /users/me/preferences | 
*UsersApi* | [**get_my_user**](docs/UsersApi.md#get_my_user) | **GET** /users/me | 
*UsersApi* | [**get_profile_image**](docs/UsersApi.md#get_profile_image) | **GET** /users/{id}/profile-image | 
*UsersApi* | [**get_user**](docs/UsersApi.md#get_user) | **GET** /users/{id} | 
*UsersApi* | [**get_user_license**](docs/UsersApi.md#get_user_license) | **GET** /users/me/license | 
*UsersApi* | [**search_users**](docs/UsersApi.md#search_users) | **GET** /users | 
*UsersApi* | [**set_user_license**](docs/UsersApi.md#set_user_license) | **PUT** /users/me/license | 
*UsersApi* | [**update_my_preferences**](docs/UsersApi.md#update_my_preferences) | **PUT** /users/me/preferences | 
*UsersApi* | [**update_my_user**](docs/UsersApi.md#update_my_user) | **PUT** /users/me | 
*UsersAdminApi* | [**create_user_admin**](docs/UsersAdminApi.md#create_user_admin) | **POST** /admin/users | 
*UsersAdminApi* | [**delete_user_admin**](docs/UsersAdminApi.md#delete_user_admin) | **DELETE** /admin/users/{id} | 
*UsersAdminApi* | [**get_user_admin**](docs/UsersAdminApi.md#get_user_admin) | **GET** /admin/users/{id} | 
*UsersAdminApi* | [**get_user_preferences_admin**](docs/UsersAdminApi.md#get_user_preferences_admin) | **GET** /admin/users/{id}/preferences | 
*UsersAdminApi* | [**get_user_statistics_admin**](docs/UsersAdminApi.md#get_user_statistics_admin) | **GET** /admin/users/{id}/statistics | 
*UsersAdminApi* | [**restore_user_admin**](docs/UsersAdminApi.md#restore_user_admin) | **POST** /admin/users/{id}/restore | 
*UsersAdminApi* | [**search_users_admin**](docs/UsersAdminApi.md#search_users_admin) | **GET** /admin/users | 
*UsersAdminApi* | [**update_user_admin**](docs/UsersAdminApi.md#update_user_admin) | **PUT** /admin/users/{id} | 
*UsersAdminApi* | [**update_user_preferences_admin**](docs/UsersAdminApi.md#update_user_preferences_admin) | **PUT** /admin/users/{id}/preferences | 
*ViewApi* | [**get_assets_by_original_path**](docs/ViewApi.md#get_assets_by_original_path) | **GET** /view/folder | 
*ViewApi* | [**get_unique_original_paths**](docs/ViewApi.md#get_unique_original_paths) | **GET** /view/folder/unique-paths | 


## Documentation For Models

 - [APIKeyCreateDto](docs/APIKeyCreateDto.md)
 - [APIKeyCreateResponseDto](docs/APIKeyCreateResponseDto.md)
 - [APIKeyResponseDto](docs/APIKeyResponseDto.md)
 - [APIKeyUpdateDto](docs/APIKeyUpdateDto.md)
 - [ActivityCreateDto](docs/ActivityCreateDto.md)
 - [ActivityResponseDto](docs/ActivityResponseDto.md)
 - [ActivityStatisticsResponseDto](docs/ActivityStatisticsResponseDto.md)
 - [AddUsersDto](docs/AddUsersDto.md)
 - [AdminOnboardingUpdateDto](docs/AdminOnboardingUpdateDto.md)
 - [AlbumResponseDto](docs/AlbumResponseDto.md)
 - [AlbumStatisticsResponseDto](docs/AlbumStatisticsResponseDto.md)
 - [AlbumUserAddDto](docs/AlbumUserAddDto.md)
 - [AlbumUserCreateDto](docs/AlbumUserCreateDto.md)
 - [AlbumUserResponseDto](docs/AlbumUserResponseDto.md)
 - [AlbumUserRole](docs/AlbumUserRole.md)
 - [AllJobStatusResponseDto](docs/AllJobStatusResponseDto.md)
 - [AssetBulkDeleteDto](docs/AssetBulkDeleteDto.md)
 - [AssetBulkUpdateDto](docs/AssetBulkUpdateDto.md)
 - [AssetBulkUploadCheckDto](docs/AssetBulkUploadCheckDto.md)
 - [AssetBulkUploadCheckItem](docs/AssetBulkUploadCheckItem.md)
 - [AssetBulkUploadCheckResponseDto](docs/AssetBulkUploadCheckResponseDto.md)
 - [AssetBulkUploadCheckResult](docs/AssetBulkUploadCheckResult.md)
 - [AssetDeltaSyncDto](docs/AssetDeltaSyncDto.md)
 - [AssetDeltaSyncResponseDto](docs/AssetDeltaSyncResponseDto.md)
 - [AssetFaceCreateDto](docs/AssetFaceCreateDto.md)
 - [AssetFaceDeleteDto](docs/AssetFaceDeleteDto.md)
 - [AssetFaceResponseDto](docs/AssetFaceResponseDto.md)
 - [AssetFaceUpdateDto](docs/AssetFaceUpdateDto.md)
 - [AssetFaceUpdateItem](docs/AssetFaceUpdateItem.md)
 - [AssetFaceWithoutPersonResponseDto](docs/AssetFaceWithoutPersonResponseDto.md)
 - [AssetFullSyncDto](docs/AssetFullSyncDto.md)
 - [AssetIdsDto](docs/AssetIdsDto.md)
 - [AssetIdsResponseDto](docs/AssetIdsResponseDto.md)
 - [AssetJobName](docs/AssetJobName.md)
 - [AssetJobsDto](docs/AssetJobsDto.md)
 - [AssetMediaResponseDto](docs/AssetMediaResponseDto.md)
 - [AssetMediaSize](docs/AssetMediaSize.md)
 - [AssetMediaStatus](docs/AssetMediaStatus.md)
 - [AssetOrder](docs/AssetOrder.md)
 - [AssetResponseDto](docs/AssetResponseDto.md)
 - [AssetStackResponseDto](docs/AssetStackResponseDto.md)
 - [AssetStatsResponseDto](docs/AssetStatsResponseDto.md)
 - [AssetTypeEnum](docs/AssetTypeEnum.md)
 - [AssetVisibility](docs/AssetVisibility.md)
 - [AudioCodec](docs/AudioCodec.md)
 - [AuthStatusResponseDto](docs/AuthStatusResponseDto.md)
 - [AvatarUpdate](docs/AvatarUpdate.md)
 - [BulkIdResponseDto](docs/BulkIdResponseDto.md)
 - [BulkIdsDto](docs/BulkIdsDto.md)
 - [CLIPConfig](docs/CLIPConfig.md)
 - [CQMode](docs/CQMode.md)
 - [ChangePasswordDto](docs/ChangePasswordDto.md)
 - [CheckExistingAssetsDto](docs/CheckExistingAssetsDto.md)
 - [CheckExistingAssetsResponseDto](docs/CheckExistingAssetsResponseDto.md)
 - [Colorspace](docs/Colorspace.md)
 - [CreateAlbumDto](docs/CreateAlbumDto.md)
 - [CreateLibraryDto](docs/CreateLibraryDto.md)
 - [CreateProfileImageResponseDto](docs/CreateProfileImageResponseDto.md)
 - [DatabaseBackupConfig](docs/DatabaseBackupConfig.md)
 - [DownloadArchiveInfo](docs/DownloadArchiveInfo.md)
 - [DownloadInfoDto](docs/DownloadInfoDto.md)
 - [DownloadResponse](docs/DownloadResponse.md)
 - [DownloadResponseDto](docs/DownloadResponseDto.md)
 - [DownloadUpdate](docs/DownloadUpdate.md)
 - [DuplicateDetectionConfig](docs/DuplicateDetectionConfig.md)
 - [DuplicateResponseDto](docs/DuplicateResponseDto.md)
 - [EmailNotificationsResponse](docs/EmailNotificationsResponse.md)
 - [EmailNotificationsUpdate](docs/EmailNotificationsUpdate.md)
 - [ExifResponseDto](docs/ExifResponseDto.md)
 - [FaceDto](docs/FaceDto.md)
 - [FacialRecognitionConfig](docs/FacialRecognitionConfig.md)
 - [FoldersResponse](docs/FoldersResponse.md)
 - [FoldersUpdate](docs/FoldersUpdate.md)
 - [ImageFormat](docs/ImageFormat.md)
 - [JobCommand](docs/JobCommand.md)
 - [JobCommandDto](docs/JobCommandDto.md)
 - [JobCountsDto](docs/JobCountsDto.md)
 - [JobCreateDto](docs/JobCreateDto.md)
 - [JobName](docs/JobName.md)
 - [JobSettingsDto](docs/JobSettingsDto.md)
 - [JobStatusDto](docs/JobStatusDto.md)
 - [LibraryResponseDto](docs/LibraryResponseDto.md)
 - [LibraryStatsResponseDto](docs/LibraryStatsResponseDto.md)
 - [LicenseKeyDto](docs/LicenseKeyDto.md)
 - [LicenseResponseDto](docs/LicenseResponseDto.md)
 - [LogLevel](docs/LogLevel.md)
 - [LoginCredentialDto](docs/LoginCredentialDto.md)
 - [LoginResponseDto](docs/LoginResponseDto.md)
 - [LogoutResponseDto](docs/LogoutResponseDto.md)
 - [ManualJobName](docs/ManualJobName.md)
 - [MapMarkerResponseDto](docs/MapMarkerResponseDto.md)
 - [MapReverseGeocodeResponseDto](docs/MapReverseGeocodeResponseDto.md)
 - [MemoriesResponse](docs/MemoriesResponse.md)
 - [MemoriesUpdate](docs/MemoriesUpdate.md)
 - [MemoryCreateDto](docs/MemoryCreateDto.md)
 - [MemoryResponseDto](docs/MemoryResponseDto.md)
 - [MemoryType](docs/MemoryType.md)
 - [MemoryUpdateDto](docs/MemoryUpdateDto.md)
 - [MergePersonDto](docs/MergePersonDto.md)
 - [MetadataSearchDto](docs/MetadataSearchDto.md)
 - [NotificationCreateDto](docs/NotificationCreateDto.md)
 - [NotificationDeleteAllDto](docs/NotificationDeleteAllDto.md)
 - [NotificationDto](docs/NotificationDto.md)
 - [NotificationLevel](docs/NotificationLevel.md)
 - [NotificationType](docs/NotificationType.md)
 - [NotificationUpdateAllDto](docs/NotificationUpdateAllDto.md)
 - [NotificationUpdateDto](docs/NotificationUpdateDto.md)
 - [OAuthAuthorizeResponseDto](docs/OAuthAuthorizeResponseDto.md)
 - [OAuthCallbackDto](docs/OAuthCallbackDto.md)
 - [OAuthConfigDto](docs/OAuthConfigDto.md)
 - [OAuthTokenEndpointAuthMethod](docs/OAuthTokenEndpointAuthMethod.md)
 - [OnThisDayDto](docs/OnThisDayDto.md)
 - [PartnerDirection](docs/PartnerDirection.md)
 - [PartnerResponseDto](docs/PartnerResponseDto.md)
 - [PeopleResponse](docs/PeopleResponse.md)
 - [PeopleResponseDto](docs/PeopleResponseDto.md)
 - [PeopleUpdate](docs/PeopleUpdate.md)
 - [PeopleUpdateDto](docs/PeopleUpdateDto.md)
 - [PeopleUpdateItem](docs/PeopleUpdateItem.md)
 - [Permission](docs/Permission.md)
 - [PersonCreateDto](docs/PersonCreateDto.md)
 - [PersonResponseDto](docs/PersonResponseDto.md)
 - [PersonStatisticsResponseDto](docs/PersonStatisticsResponseDto.md)
 - [PersonUpdateDto](docs/PersonUpdateDto.md)
 - [PersonWithFacesResponseDto](docs/PersonWithFacesResponseDto.md)
 - [PinCodeChangeDto](docs/PinCodeChangeDto.md)
 - [PinCodeResetDto](docs/PinCodeResetDto.md)
 - [PinCodeSetupDto](docs/PinCodeSetupDto.md)
 - [PlacesResponseDto](docs/PlacesResponseDto.md)
 - [PurchaseResponse](docs/PurchaseResponse.md)
 - [PurchaseUpdate](docs/PurchaseUpdate.md)
 - [QueueStatusDto](docs/QueueStatusDto.md)
 - [RandomSearchDto](docs/RandomSearchDto.md)
 - [RatingsResponse](docs/RatingsResponse.md)
 - [RatingsUpdate](docs/RatingsUpdate.md)
 - [ReactionLevel](docs/ReactionLevel.md)
 - [ReactionType](docs/ReactionType.md)
 - [ReverseGeocodingStateResponseDto](docs/ReverseGeocodingStateResponseDto.md)
 - [SearchAlbumResponseDto](docs/SearchAlbumResponseDto.md)
 - [SearchAssetResponseDto](docs/SearchAssetResponseDto.md)
 - [SearchExploreItem](docs/SearchExploreItem.md)
 - [SearchExploreResponseDto](docs/SearchExploreResponseDto.md)
 - [SearchFacetCountResponseDto](docs/SearchFacetCountResponseDto.md)
 - [SearchFacetResponseDto](docs/SearchFacetResponseDto.md)
 - [SearchResponseDto](docs/SearchResponseDto.md)
 - [SearchSuggestionType](docs/SearchSuggestionType.md)
 - [ServerAboutResponseDto](docs/ServerAboutResponseDto.md)
 - [ServerConfigDto](docs/ServerConfigDto.md)
 - [ServerFeaturesDto](docs/ServerFeaturesDto.md)
 - [ServerMediaTypesResponseDto](docs/ServerMediaTypesResponseDto.md)
 - [ServerPingResponse](docs/ServerPingResponse.md)
 - [ServerStatsResponseDto](docs/ServerStatsResponseDto.md)
 - [ServerStorageResponseDto](docs/ServerStorageResponseDto.md)
 - [ServerThemeDto](docs/ServerThemeDto.md)
 - [ServerVersionHistoryResponseDto](docs/ServerVersionHistoryResponseDto.md)
 - [ServerVersionResponseDto](docs/ServerVersionResponseDto.md)
 - [SessionCreateDto](docs/SessionCreateDto.md)
 - [SessionCreateResponseDto](docs/SessionCreateResponseDto.md)
 - [SessionResponseDto](docs/SessionResponseDto.md)
 - [SessionUnlockDto](docs/SessionUnlockDto.md)
 - [SharedLinkCreateDto](docs/SharedLinkCreateDto.md)
 - [SharedLinkEditDto](docs/SharedLinkEditDto.md)
 - [SharedLinkResponseDto](docs/SharedLinkResponseDto.md)
 - [SharedLinkType](docs/SharedLinkType.md)
 - [SharedLinksResponse](docs/SharedLinksResponse.md)
 - [SharedLinksUpdate](docs/SharedLinksUpdate.md)
 - [SignUpDto](docs/SignUpDto.md)
 - [SmartSearchDto](docs/SmartSearchDto.md)
 - [SourceType](docs/SourceType.md)
 - [StackCreateDto](docs/StackCreateDto.md)
 - [StackResponseDto](docs/StackResponseDto.md)
 - [StackUpdateDto](docs/StackUpdateDto.md)
 - [SyncAckDeleteDto](docs/SyncAckDeleteDto.md)
 - [SyncAckDto](docs/SyncAckDto.md)
 - [SyncAckSetDto](docs/SyncAckSetDto.md)
 - [SyncAlbumDeleteV1](docs/SyncAlbumDeleteV1.md)
 - [SyncAlbumUserDeleteV1](docs/SyncAlbumUserDeleteV1.md)
 - [SyncAlbumUserV1](docs/SyncAlbumUserV1.md)
 - [SyncAlbumV1](docs/SyncAlbumV1.md)
 - [SyncAssetDeleteV1](docs/SyncAssetDeleteV1.md)
 - [SyncAssetExifV1](docs/SyncAssetExifV1.md)
 - [SyncAssetV1](docs/SyncAssetV1.md)
 - [SyncEntityType](docs/SyncEntityType.md)
 - [SyncPartnerDeleteV1](docs/SyncPartnerDeleteV1.md)
 - [SyncPartnerV1](docs/SyncPartnerV1.md)
 - [SyncRequestType](docs/SyncRequestType.md)
 - [SyncStreamDto](docs/SyncStreamDto.md)
 - [SyncUserDeleteV1](docs/SyncUserDeleteV1.md)
 - [SyncUserV1](docs/SyncUserV1.md)
 - [SystemConfigBackupsDto](docs/SystemConfigBackupsDto.md)
 - [SystemConfigDto](docs/SystemConfigDto.md)
 - [SystemConfigFFmpegDto](docs/SystemConfigFFmpegDto.md)
 - [SystemConfigFacesDto](docs/SystemConfigFacesDto.md)
 - [SystemConfigGeneratedFullsizeImageDto](docs/SystemConfigGeneratedFullsizeImageDto.md)
 - [SystemConfigGeneratedImageDto](docs/SystemConfigGeneratedImageDto.md)
 - [SystemConfigImageDto](docs/SystemConfigImageDto.md)
 - [SystemConfigJobDto](docs/SystemConfigJobDto.md)
 - [SystemConfigLibraryDto](docs/SystemConfigLibraryDto.md)
 - [SystemConfigLibraryScanDto](docs/SystemConfigLibraryScanDto.md)
 - [SystemConfigLibraryWatchDto](docs/SystemConfigLibraryWatchDto.md)
 - [SystemConfigLoggingDto](docs/SystemConfigLoggingDto.md)
 - [SystemConfigMachineLearningDto](docs/SystemConfigMachineLearningDto.md)
 - [SystemConfigMapDto](docs/SystemConfigMapDto.md)
 - [SystemConfigMetadataDto](docs/SystemConfigMetadataDto.md)
 - [SystemConfigNewVersionCheckDto](docs/SystemConfigNewVersionCheckDto.md)
 - [SystemConfigNotificationsDto](docs/SystemConfigNotificationsDto.md)
 - [SystemConfigOAuthDto](docs/SystemConfigOAuthDto.md)
 - [SystemConfigPasswordLoginDto](docs/SystemConfigPasswordLoginDto.md)
 - [SystemConfigReverseGeocodingDto](docs/SystemConfigReverseGeocodingDto.md)
 - [SystemConfigServerDto](docs/SystemConfigServerDto.md)
 - [SystemConfigSmtpDto](docs/SystemConfigSmtpDto.md)
 - [SystemConfigSmtpTransportDto](docs/SystemConfigSmtpTransportDto.md)
 - [SystemConfigStorageTemplateDto](docs/SystemConfigStorageTemplateDto.md)
 - [SystemConfigTemplateEmailsDto](docs/SystemConfigTemplateEmailsDto.md)
 - [SystemConfigTemplateStorageOptionDto](docs/SystemConfigTemplateStorageOptionDto.md)
 - [SystemConfigTemplatesDto](docs/SystemConfigTemplatesDto.md)
 - [SystemConfigThemeDto](docs/SystemConfigThemeDto.md)
 - [SystemConfigTrashDto](docs/SystemConfigTrashDto.md)
 - [SystemConfigUserDto](docs/SystemConfigUserDto.md)
 - [TagBulkAssetsDto](docs/TagBulkAssetsDto.md)
 - [TagBulkAssetsResponseDto](docs/TagBulkAssetsResponseDto.md)
 - [TagCreateDto](docs/TagCreateDto.md)
 - [TagResponseDto](docs/TagResponseDto.md)
 - [TagUpdateDto](docs/TagUpdateDto.md)
 - [TagUpsertDto](docs/TagUpsertDto.md)
 - [TagsResponse](docs/TagsResponse.md)
 - [TagsUpdate](docs/TagsUpdate.md)
 - [TemplateDto](docs/TemplateDto.md)
 - [TemplateResponseDto](docs/TemplateResponseDto.md)
 - [TestEmailResponseDto](docs/TestEmailResponseDto.md)
 - [TimeBucketAssetResponseDto](docs/TimeBucketAssetResponseDto.md)
 - [TimeBucketsResponseDto](docs/TimeBucketsResponseDto.md)
 - [ToneMapping](docs/ToneMapping.md)
 - [TranscodeHWAccel](docs/TranscodeHWAccel.md)
 - [TranscodePolicy](docs/TranscodePolicy.md)
 - [TrashResponseDto](docs/TrashResponseDto.md)
 - [UpdateAlbumDto](docs/UpdateAlbumDto.md)
 - [UpdateAlbumUserDto](docs/UpdateAlbumUserDto.md)
 - [UpdateAssetDto](docs/UpdateAssetDto.md)
 - [UpdateLibraryDto](docs/UpdateLibraryDto.md)
 - [UpdatePartnerDto](docs/UpdatePartnerDto.md)
 - [UsageByUserDto](docs/UsageByUserDto.md)
 - [UserAdminCreateDto](docs/UserAdminCreateDto.md)
 - [UserAdminDeleteDto](docs/UserAdminDeleteDto.md)
 - [UserAdminResponseDto](docs/UserAdminResponseDto.md)
 - [UserAdminUpdateDto](docs/UserAdminUpdateDto.md)
 - [UserAvatarColor](docs/UserAvatarColor.md)
 - [UserLicense](docs/UserLicense.md)
 - [UserPreferencesResponseDto](docs/UserPreferencesResponseDto.md)
 - [UserPreferencesUpdateDto](docs/UserPreferencesUpdateDto.md)
 - [UserResponseDto](docs/UserResponseDto.md)
 - [UserStatus](docs/UserStatus.md)
 - [UserUpdateMeDto](docs/UserUpdateMeDto.md)
 - [ValidateAccessTokenResponseDto](docs/ValidateAccessTokenResponseDto.md)
 - [ValidateLibraryDto](docs/ValidateLibraryDto.md)
 - [ValidateLibraryImportPathResponseDto](docs/ValidateLibraryImportPathResponseDto.md)
 - [ValidateLibraryResponseDto](docs/ValidateLibraryResponseDto.md)
 - [VersionCheckStateResponseDto](docs/VersionCheckStateResponseDto.md)
 - [VideoCodec](docs/VideoCodec.md)
 - [VideoContainer](docs/VideoContainer.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearer"></a>
### bearer

- **Type**: Bearer authentication (JWT)

<a id="cookie"></a>
### cookie

- **Type**: API key
- **API key parameter name**: immich_access_token
- **Location**: 

<a id="api_key"></a>
### api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author




